#ifndef _STAR_PACKET_H_
#define _STAR_PACKET_H_
#include "RawPacket.h"
#include <string.h>
#include <iostream>
#include <stdio.h>
#include <stdint.h>
#include "md5.h"

#ifndef ETH_P_8021X
#define ETH_P_8021X 0x888E
#endif

/* packet[0x12]  */
#define ST_START 1
#define ST_AUTH 0
#define ST_ECHO 0xBF

#define SF_REQUEST 1
#define SF_RESPONSE 2
#define SF_SUCCESS 3
#define SF_FAILURE 4

#define SI_IDENTITY 1
#define SI_PASSWORD 4

#define ETH_P_8021X 0x888E

class StarPacket: public RawPacket 
{
public:
  char user[32];
  char passwd[32];
  char message[256];
  StarPacket(char *dev);
  int Parse();
  unsigned char* Build();
  unsigned char* BuildEcho();
  int FillParam(unsigned char * p);
  int Crypt(unsigned char * p, int size);
	
protected:
  unsigned char type;  /* 1:㲥, 0:auth, 2: logoff, 0xbf: echo */
  unsigned char flag; /* 1:requrest, 2:response, 3:success, 4:faluire */
  unsigned char id;            /* 0x13, md5ܵʱҲҪõ */
  unsigned char info;          /* 1: identiry, 4: password */
  unsigned char key_len;       /* md5Կ */
  unsigned char key[0x10];     /* ȡmd5Կ */
  unsigned char dest[6];   /* Ŀַ */
  unsigned char mac[6];
  unsigned short magic;        /* echoʱһmagic,0x010A */
  unsigned short echo_key;     /* echoʱkey */
  //  uint32_t ip;
  //  uint32_t mask;
  uint32_t gate;
  uint32_t dns;
  int verbose;
};

#endif
